ents = {}
ents.objects = {}
ents.objpath = "entities/"
local entFactory = {}
local id = 0

function ents.Register(entName)
	entFactory[entName] = love.filesystem.load( ents.objpath .. entName .. ".lua" )
end

function ents.Derive(name)
	return love.filesystem.load( ents.objpath .. name .. ".lua" )() --() behind load() runs the loaded chunk from the lua file.
end

function ents.Create(name, x, y, BG)
	if not x then
		x = 0
	end
	
	if not y then
		y = 0
	end
	
	if not BG then
		BG = false
	end
	
	if entFactory[name] then
		id = id + 1
		local ent = entFactory[name]()
		ent:load()
		ent.type = name
		ent:setPos(x, y)
		ent.id = id
		ent.BG = BG
		ents.objects[id] = ent
		return ents.objects[id]
	else
		print("Error: Entity " .. name .. " does not exist! Snap!")
		return false;
	end
end

function ents.Destroy( id )
	if ents.objects[id] then
		if ents.objects[id].Die then
			ents.objects[id]:Die()
		end
		ents.objects[id] = nil
	end
end

function ents:update(dt)
	for i, ent in pairs(ents.objects) do
		if ent.update then
			ent:update(dt)
		end
	end
end

function ents:draw()
	for i, ent in pairs(ents.objects) do
		if not ent.BG then
			if ent.draw then
				ent:draw()
			end
		end
	end
end
