local ship =  ents.Derive("base")

function ship:spawn()
	self.isAlive = true
	self.team = 2
	self.radius = 1
	self.rot = 0
	self:setSpeed(SHIP_SPEED +20)
end

function ship:setSpeed(speed)
	self.speed = speed
end


function ship:setTarget(object)
	self.destX = object.x
	self.destY = object.y
end

function ship:distance(x,y)
	return distance(self.x,self.y, x,y)
end

function ship:load()
end

-- Is it in the camera's view
function ship:isVisible()
	sx,sy = self:getSize()
	if (self.x + sx >= camX - (cX / zoomScale) and self.x - sx <= camX + (cX / zoomScale)) and 
	 (self.y + sy >= camY - (cY / zoomScale) and self.y - sy <= camY + (cY / zoomScale))then
		return true
	else
		return false
	end
end

function ship:draw(dt)
	if not( self.isAlive and self:isVisible() )then return end
	local color = TEAM_COLORS[self.team]
	love.graphics.setColor( color[1], color[2], color[3], 255 ) 
	
	love.graphics.setPointStyle( "rough" )
	love.graphics.setPointSize(self.radius*zoomScale)
	love.graphics.point(self.x * zoomScale,  -self.y * zoomScale)   -- draw each point
	--love.graphics.circle("fill",  self.x * zoomScale,  -self.y * zoomScale, self.radius * zoomScale, 4) -- NEGATE Y!
	
end

--Gets the X and Y bounds of the entity
function ship:getSize()
	return 5,5 -- Arbitrary value... No significant meaning.
end

function ship:update(dt)

	maxDist = self.speed * dt
	dist = self:distance(self.destX, self.destY)

	-- This doesnt work flawlessly... but good enough for now.
	if dist <= maxDist then
		self.x = self.destX
		self.y = self.destY
	else
		 --Find current direction vector
		local dirx = math.cos( self.rot )
		local diry = math.sin( self.rot )

		-- Targets direction vector
		headX = self.destX - self.x
		headY = self.destY - self.y

		ship.rot = math.atan(headY / headX)
		
		if headX < dirx then
			ship.rot = ship.rot + PI
		end
		--[[
		-- RRRRRRRRRRAAAAAAAWWWWWWWWWWRRRRRRRRR! Cant figure this out.
		
		--Add a value scaled by dt to rotate orientation
		if self.rot < ship.desiredRot then
			self.rot = self.rot - math.min(SHIP_ROTSPEED * dt, ship.desiredRot - self.rot)
			--Bound checking for pi and -pi
			if self.rot > PI then
				self.rot = -PI
			elseif self.rot < -PI then
				self.rot = PI
			end
		--Subtract a value scaled by dt to rotate orientation
		elseif self.rot > ship.desiredRot then
		  self.rot = self.rot + math.min(SHIP_ROTSPEED * dt, ship.desiredRot - self.rot)
		  --Bound checking for pi and -pi
			if self.rot > PI then
				self.rot = -PI
			elseif self.rot < -PI then
				self.rot = PI
			end
		end
		--]]
	
		--Update position with our new calculated values
		self.x = self.x + dirx*math.min(dist, maxDist)
		self.y = self.y + diry*math.min(dist, maxDist)
	end
end

return ship;